/* ***** <NB> *****
 *
 * Огромнейшее человеческое спасибо:
 *      - Владимиру Паланту (http://xpoint.ru/forums/thread.xhtml?id=27554)
 *        и другим авторам "Adblock" (http://adblock.mozdev.org);
 *      - Авторам FlashBlock (http://flashblock.mozdev.org/).
 *
 * А так же:
 *      - Разработчикам Mozilla за предоставленную возможность
 *        порезвиться с js. Хотя лучше бы я просто поспал.
 *        (https://bugzilla.mozilla.org/show_bug.cgi?id=47475)
 *
 * Ну и
 *      "Всем тем, кто отдал свою душу Ветру..."
 *
 * ***** </NB> ***** */

/* ***** <Policy values> *****
 *
 * 1 -- Load all images
 * 2 -- Load images for this site only
 * 3 -- Load cached images only
 * 4 -- Don't load images
 *
 * ***** </Policy values> ***** */

    /** Bug 306243, https://bugzilla.mozilla.org/show_bug.cgi?id=306243
        When browser.tabs.autohide is enabled, toolbar customisation settings are
        ignored after restarting Firefox; extensions' icons are missing from the palette
    **/

var ILO = {
  
  browser:           getBrowser(),
  
  nsIImgLikeOpera:   Components.classes["@mozilla.org/imglikeopera;1"]
                               .getService(Components.interfaces.nsIImgLikeOpera)
                               .wrappedJSObject,
  
  /************************************************************************
   *
   * Get selected tab and document
   *
   ************************************************************************/
  getTabAndDoc: function(aTab) {
    let tab = aTab || this.browser.selectedBrowser;
    
    let doc = tab.contentDocument.defaultView.document;
    if (!doc.iloData)
      doc.iloData = this.nsIImgLikeOpera.setupDocData(tab);
    
    return [tab, doc];
  },
  
  /************************************************************************
   *
   * XPath helpers
   *
   ************************************************************************/
  getXPathResult: function(aDocument, aExpression) {
    let xpe = new XPathEvaluator();
    let nsResolver = xpe.createNSResolver(aDocument.documentElement);
    return xpe.evaluate(aExpression, aDocument, nsResolver, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
  },
  
  forEachXPathResult: function(aDocument, aExpression, aFunction) {
    let result = this.getXPathResult(aDocument, aExpression);
    for (let i = result.snapshotLength; --i >= 0;)
      aFunction(result.snapshotItem(i));
  },
  
  /************************************************************************
   *
   * Page indicator (bottom-right-button): popup, click
   *
   ************************************************************************/
  
  /** **************************** **
   **  2do, 2do, 2do...
   ** **************************** **/
  
  checkStatusbarClick: function(e) {
    switch (e.button) {
      case 1:
        this.openSettingsWindow();
        break;
      
      case 2:
        this.indicatorClick("-1");
        break;
      
      case 0:
        if (e.target.id == "ilo-statusbar-button-arrow")
          e.target.parentNode.lastChild.showPopup(e.target,-1,-1,"popup","bottomleft","topleft");
        else
          this.indicatorClick();
        break;
    }
  },
  
  checkClick: function(aEvent) {
    let node = aEvent.target;
    
    if (node.localName == "toolbarbutton") {
      if (aEvent.button == 1)
        this.openSettingsWindow();
      else if (aEvent.button == 2)
        this.indicatorClick("-1");
      return;
    }
    
    aEvent.stopPropagation();
    
    if (aEvent.button == 1) {
      let fn = new Function("event", node.getAttribute("oncommand"));//node.oncommand(event): bug 246720 not fixed
      fn.call(node, aEvent);
      
      this.closeMenus(node);
    }
  },
  
  closeMenus: function(node) {
    if ("tagName" in node) {
      if (node.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
          && (node.tagName == "menupopup" || node.tagName == "popup"))
        node.hidePopup();
      
      this.closeMenus(node.parentNode);
    }
  },
  
  openSettingsWindow: function() {
    const wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                         .getService(Components.interfaces.nsIWindowMediator);
    
    let settingsWindow = wm.getMostRecentWindow("imglikeoperaSettingsWindow");
    
    if (settingsWindow)
      settingsWindow.focus();
    else
      window.open("chrome://imglikeopera/content/options.xul","","chrome,centerscreen,resizable");
  },
  
  indicatorClick: function(policy) {
    if (policy == "settings")
      return this.openSettingsWindow();
    
    let [tab, doc] = this.getTabAndDoc();
    
    if (!policy) {
      //~ left-mouse-click
      policy = (tab.iloTabPolicy - 1) || 4;
    } else if (policy == "-1") {
      //~ right-mouse-click
      policy = tab.iloTabPolicy + 1;
      if (policy == 5)
        policy = 1;
    }
    
    policy -= 0;
    
    if (policy != tab.iloTabPolicy) {
      tab.iloTabPolicy = doc.iloData.policy = policy;
      doc.iloData.clearURLStatus();
      
      this.indicatorSet(policy);
      
      if (policy != 4)
        this.refreshPageObjects(doc);
    }
    
    return true;
  },

  indicatorPopup: function() {
    let indicatorPopupItems = this.button.lastChild.childNodes;
    
    for (let k = 4; --k > -1;) {
      if (indicatorPopupItems[k].getAttribute("checked") != "false")
        indicatorPopupItems[k].setAttribute("checked", "false");
    }
    
    indicatorPopupItems[ 4 - this.browser.selectedBrowser.iloTabPolicy ].setAttribute("checked", "true");
  },
  
  indicatorSet: function(policy) {
    this.sessionStore.setTabPolicy(this.browser.selectedTab, policy);
    
    let b = this.button;
    b.setAttribute("value", "policy" + policy);
    
    if (b.getAttribute("label"))
      b.setAttribute("label", "ILO [" + this.strBundleManager.getString("buttonPolicy" + policy) + "]");
  },
  
  /************************************************************************
   *
   * 1) contentAreaContextMenu --> popupshowing --> ilo-context-menu-load-image
   * 2) ctrl + rigthMouseClick
   *
   ************************************************************************/
  loadImg: function(aTargets) {
    if (!aTargets)
      return;
    
    let doc = null;
    [].concat(aTargets).forEach(function(target) {
      doc = this._loadImg(target);
    }, this);
    
    if (doc)
      this.refreshPageStyles(doc);
  },
  
  _loadImg: function(obj) {
    let objsrc = obj ? obj.getAttribute("ilo-full-src") : null;//~ "ilo-full-src" need for inputs with type="image"
    
    if (!objsrc)
      return;
    
    let [tab, doc] = this.getTabAndDoc();
    
    doc.iloData.passURL(objsrc);
    
    //~ if policy == "Don't load images" ==> turn it to "Load from cache"
    if (tab.iloTabPolicy == 4) {
      tab.iloTabPolicy = doc.iloData.policy = 3;
      this.indicatorSet(3);
    }
    
    if (!obj.getAttribute("ilo-ph-fix"))
      this.nsIImgLikeOpera.removeCacheEntry(objsrc);
    
    this.refreshPageObjects(doc, objsrc);
    return doc;
  },
  
  /************************************************************************
   *
   * Refresh images|styles in document
   *
   ************************************************************************/
 
  getAllDocs: function(aFrameset) {
    let docsArray = [aFrameset.document];
    let frames = aFrameset.frames;
    
    for (let i = frames.length; --i > -1;)
      docsArray = docsArray.concat(this.getAllDocs(frames[i]));
    
    return docsArray;
  },

  refreshPageObjects: function(doc, objsrc) {
    if (doc.iloData.delayPolicy)
      doc.iloData.delayPolicy = null;
    
    this.getAllDocs(doc.defaultView).forEach(function(aDoc) {
      this.refreshObjectsInFrame(aDoc, objsrc);
      
      if (!objsrc)
        this.refreshStyles(aDoc);
    }, this);
  },
  
  refreshPageStyles: function(doc) {
    if (doc.iloData.delayPolicy)
      doc.iloData.delayPolicy = null;
    
    this.getAllDocs(doc.defaultView).forEach(function(aDoc) {
      this.refreshStyles(aDoc);
    }, this);
  },
  
  refreshObjectsInFrame: function(doc, objsrc) {
    this.forEachXPathResult(doc,
      
      "//*" + (objsrc ? "[@ilo-full-src='" + objsrc + "']" : "[@ilo-ph-fix]"),
      
      function(aObject) {
        objsrc ?
          aObject.setAttribute("ilo-ph-fix", "mustLoad") :
          aObject.removeAttribute("ilo-ph-fix");
        
        if (aObject.hasAttribute("src")) {
          aObject.setAttribute("src", aObject.getAttribute("src"));
        }
        else if (aObject.hasAttribute("data")) {
          let dbl = aObject.cloneNode(true),
              parent = aObject.parentNode;
          
          parent.insertBefore(dbl, aObject);
          parent.removeChild(aObject);
        }
      }
    );
  },
  
  refreshCssRules: function(aSheet) {
    let cssRules = null;
    
    try {
      cssRules = aSheet.cssRules;
    } catch(e) {}
    
    if (!(cssRules && cssRules.length))
      return;
    
    let cssRule,
        i = 0;
    
    while (( cssRule = cssRules.item(i++) )) {
      if (cssRule.styleSheet)
        this.refreshCssRules(cssRule.styleSheet);
      else {
        let style = cssRule.style,
            cssText = cssRule.cssText;
        
        if (style && cssText) {
          if (/background.*url/.test(cssText))
            style.backgroundImage = style.backgroundImage;
          
          if (/list\-style.*url/.test(cssText))
            style.listStyleImage = style.listStyleImage;
          
          if (/content:/.test(cssText))
            style.content = style.content;
        }
      }
    }
  },
  
  refreshStyles: function(doc) {
    //~ inline styles
    this.forEachXPathResult(doc,
      
      "//*[contains(@style,'url')]",
      
      function(aObject) {
        aObject.style.backgroundImage = aObject.style.backgroundImage;
      }
    );
    
    this.forEachXPathResult(doc,
      
      "//*[@background]",
      
      function(aObject) {
        aObject.setAttribute("style",
            "background-image:url('" + aObject.getAttribute("background") + "'); " +
            (aObject.getAttribute("style") || ""));
        aObject.removeAttribute("background");
      }
    );
    
    //~ <link>, <style>, <xml-stylesheet>
    let docStyleSheets = doc.styleSheets,
        styleSheet,
        i = 0;
    
    while (( styleSheet = docStyleSheets.item(i++) )) {
      if (/^$|all|screen|projection/.test(styleSheet.media.mediaText)) {
        var styleSheetNode = styleSheet.ownerNode;
        
        //~ styleSheetNode.nodeName.toLowerCase() = "style"||"link"||"xml-stylesheet"
        //~    if "style"-node: test for inline @import rules,
        //~    like @import url("http://example.com/example.css")
        if (styleSheetNode.nodeName.toLowerCase() == "style" && !/@import/.test(styleSheetNode.textContent))
          styleSheetNode.textContent = styleSheetNode.textContent; //~ ...more simple and fast then other method
        else
          this.refreshCssRules(styleSheet);
      }
    }
  },
  
  onLoad: function() {
    window.removeEventListener("load", this.onLoad, true);
    
    this.sessionStore = this.nsIImgLikeOpera.sessionStore;
    this.settings = this.nsIImgLikeOpera.settings;
    this.strBundleManager = this.nsIImgLikeOpera.strBundleManager;
    
    /* ***** Tabs hack [start] *****
     * was (in ILO 0.6.5-):
     * Patch "browser.addTab" [tabbrowser.xml, <method name="addTab">]
     * eval('gBrowser.addTab =' + this.browser.addTab.toString().replace(__tb_from, __tb_to));
     * ******************** */
    var __tb_from = 'if (!blank)';
    var __tb_to = 'b.iloTabPolicy = ILO.settings.defaultPolicy || this.selectedBrowser.iloTabPolicy; \
                   if (!blank)';
    
    eval('gBrowser.addTab =' + this.browser.addTab.toString().replace(
      __tb_from,
      __tb_to
    ));
    
    //~ for work with TBE (like tabextensions_2.0.2005121301_en.xpi) we need this lines:
    if (this.browser.__tabextensions__addTab) {
      eval('gBrowser.__tabextensions__addTab =' + this.browser.__tabextensions__addTab.toString().replace(
        __tb_from,
        __tb_to
      ));
      
      eval('gBrowser.getTabInfo =' + this.browser.getTabInfo.toString().replace(
        'allowImages:aTab.allowImages,',
        'allowImages:aTab.allowImages, \
         iloTabPolicy:b.iloTabPolicy,'
      ));
      
      eval('gBrowser.addTabWithTabInfo =' + this.browser.addTabWithTabInfo.toString().replace(
        'for (i in props)',
        'b.iloTabPolicy = aInfo.iloTabPolicy; \
         ILO.indicatorSet(aInfo.iloTabPolicy); for (i in props)'
      ));
      
      eval('TabbrowserSessionManager.saveTabInfoTo =' + TabbrowserSessionManager.saveTabInfoTo.toString().replace(
        '"allowImages", aInfo.allowImages,',
        '"allowImages", aInfo.allowImages, \
         "iloTabPolicy", aInfo.iloTabPolicy,'
      ));
      
      eval('TabbrowserSessionManager.loadTabInfoFrom =' + TabbrowserSessionManager.loadTabInfoFrom.toString().replace(
        'fixedLabel',
        'iloTabPolicy:Number(aDatabase.getData(aRes, "iloTabPolicy")), fixedLabel'
      ));
    }
    
    //~ for work with SessionSaver (like version 0.2.1.030.4) we need this lines:
    if (this.browser.__ssAddTabMod) {
      eval('SessionSaver.captureTab =' + SessionSaver.captureTab.toString().replace(
        'tab.__ssLocalData = tabSession;',
        'if (browser && browser.iloTabPolicy) tabSession += "##ILO##" + browser.iloTabPolicy; \
         tab.__ssLocalData = tabSession;'
      ));
      
      eval('SessionSaver.historyRecall =' + SessionSaver.historyRecall.toString().replace(
        'var historyURL = entry[1];',
        'var iloTabPolicy = entry[1].split("##ILO##")[1]; \
         var historyURL = entry[1].split("##ILO##")[0];'
      ));
      
      eval('SessionSaver.historyRecall =' + SessionSaver.historyRecall.toString().replace(
        'if (isStartup && this.orbiterChild)',
        'curBrowser.iloTabPolicy = parseInt(iloTabPolicy,10); \
         if (t == selectedtab) ILO.indicatorSet(curBrowser.iloTabPolicy); \
         if (isStartup && this.orbiterChild)'
      ));
    }
    /* ***** Tabs hack [end] ***** */
    
    /* -- THIS CODE REQUIRES CRASH RECOVERY 0.5.7 -- */
    if ("@zeniko/crashrecoveryservice;1" in Components.classes) {
      eval('ILO.indicatorClick =' + this.indicatorClick.toString().replace(
        "return true;",
        'this.browser.selectedTab.setAttribute("CR_iloTabPolicy", tab.iloTabPolicy); \
         return true;'
      ));
      
      gBrowser.addEventListener("CRTabRestoring", function(aEvent) {
        var policy, tab = aEvent.originalTarget;
        if (tab.hasAttribute("CR_iloTabPolicy")) {
          policy = parseInt(tab.getAttribute("CR_iloTabPolicy"),10);
          this.getBrowserForTab(tab).iloTabPolicy = policy;
          if (tab == gBrowser.selectedTab) ILO.indicatorSet(policy);
        }
      }, false);
    }
    
    var defPolicy = this.settings.defaultPolicy;
    if (!defPolicy) {
      var openerPolicy; //~ "From previous window/tab" setting
      try {
        openerPolicy = window.opener.ILO.browser.selectedBrowser.iloTabPolicy;
      } catch(e) {}
      
      defPolicy = openerPolicy || this.settings.startupPolicy; //~ startup (first window)
    }
    
    //~ Current tab policy
    this.browser.selectedBrowser.iloTabPolicy = defPolicy;
    
    this.setButton();
    
    var toolbox = document.getElementById("navigator-toolbox");
    toolbox.addEventListener("draggesture", function(){setTimeout("ILO.setButton()",0)}, false);
    toolbox.addEventListener("dragdrop",    function(){setTimeout("ILO.setButton()",0)}, false);
    
    //~ Page-indicator.
    this.indicatorSet(defPolicy);
    
    //~ Tabs switching.
    this.browser.mTabContainer.addEventListener("select", this, true);
    
    //~ Context Menu: + "Load Image".
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this, false);
    
    //~ Ctrl+RClick for image load
    window.addEventListener("mousedown", this, false);
    
    //~ "Esc" key
    window.addEventListener("keypress", this, false);
    
    // SessionStore
    window.addEventListener("SSTabRestoring", this, false);
    
    //[2do] move hacks in another place
    /* ***** Tabs hack [start] ***** */
    //~ for work with Tab Mix Plus (like Tab Mix Plus 0.3 Beta 0.2.95.2005122500) we need this lines:
    if (typeof SessionData != "undefined") {
      eval('SessionData.getTabProperties =' + SessionData.getTabProperties.toString().replace(
        'return tabProperties + "11111";',
        'return tabProperties + "11111##ILO##" + parseInt(gBrowser.getBrowserForTab(aTab).iloTabPolicy,10);'
      ));
      
      eval('SessionData.getTabProperties =' + SessionData.getTabProperties.toString().replace(
        'return tabProperties;',
        'return tabProperties + "##ILO##" + parseInt(gBrowser.getBrowserForTab(aTab).iloTabPolicy,10);'
      ));
      
      eval('SessionData.setTabProperties =' + SessionData.setTabProperties.toString().replace(
        'if (checkPref ',
        'var curBrowser = gBrowser.getBrowserForTab(aTab); \
         curBrowser.iloTabPolicy = parseInt(tabProperties.split("##ILO##")[1],10) || curBrowser.iloTabPolicy; \
         if (gBrowser.selectedBrowser == curBrowser) ILO.indicatorSet(curBrowser.iloTabPolicy); \
         if (checkPref '
      ));
      
      eval('ILO.indicatorClick =' + this.indicatorClick.toString().replace(
        "this.refreshPageObjects(doc);\n        }",
        'this.refreshPageObjects(doc);} \
         SessionManager.updateTabProp(this.browser.selectedTab);'
      ));
    }
    /* ***** Tabs hack [end] ***** */
  },
  
  unLoad: function() {
    //[2do] remove other listeners
    
    window.removeEventListener("SSTabRestoring", this, false);
    
    this.browser.mTabContainer.removeEventListener("select", this, true);
    window.removeEventListener("mousedown", this, false);
    window.removeEventListener("keypress", this, false);
    document.getElementById("contentAreaContextMenu").removeEventListener("popupshowing", this, false);
    
    this.strBundleManager = null;
    this.settings = null;
    this.sessionStore = null;
  },
  
  // Ctrl+RClick (last mousedown event data)
  _lastMouseDownEventData: [],
  
  handleEvent: function(aEvent) {
    if (!aEvent.isTrusted)
      return;
    
    switch (aEvent.type) {
      // on tab select
      case "select":
        var [tab, doc] = this.getTabAndDoc();
        
        doc.iloData.clearURLStatus();
        
        if (this.settings.tabsRefresh)
          this.refreshPageObjects(doc);
        
        this.indicatorSet(tab.iloTabPolicy);
        
        break;
      
      // gContextMenu 'popupshowing'
      case "popupshowing":
        let [mdTS, mdSX, mdSY] = this._lastMouseDownEventData;
        if (mdTS && (Date.now() - mdTS < 1000) && mdSX == aEvent.screenX && mdSY == aEvent.screenY)
          aEvent.preventDefault();
        
        document.getElementById("ilo-context-menu-load-image").hidden = !this.getImageFromTarget(gContextMenu.target);
        break;
      
      // Ctrl+RClick
      case "mousedown":
        this._lastMouseDownEventData = [];
        
        if (aEvent.button == 2 && aEvent.ctrlKey && !(aEvent.shiftKey || aEvent.altKey)) {
          let targets = this.getImagesFromPoint(aEvent.target, aEvent.clientX, aEvent.clientY)
                            .concat(this.getImagesFromSelection());
          
          if (targets.length) {
            this.loadImg(targets);
            this._lastMouseDownEventData = [Date.now(), aEvent.screenX, aEvent.screenY];
          }
        }
        break;
      
      case "keypress":
        if (aEvent.keyCode == 27 && this.settings.escKey) {// "Esc"
          var _doc = aEvent.target.ownerDocument;
          while (_doc.defaultView.frameElement)
            _doc = _doc.defaultView.frameElement.ownerDocument;
          
          var [tab, doc] = this.getTabAndDoc();
          
          if (_doc != doc)
            return;
          
          var docShell = tab.docShell;
          docShell["allowImages"] = !docShell["allowImages"];
          docShell["allowImages"] = !docShell["allowImages"];
          //~ docShell["allowPlugins"] for active content?!
        }
        break;
      
      case "delayLoadRefresher":
        var doc = aEvent.target;
        if (doc.iloData.delayPolicy) {
          doc.iloData.delayPolicy = null;
          this.refreshPageObjects(doc);
        }
        break;
      
      // tab restoring
      case "SSTabRestoring":
        var tab = aEvent.originalTarget;
        var policy = this.sessionStore.getTabPolicy(tab);
        
        if (policy) {
          gBrowser.getBrowserForTab(tab).iloTabPolicy = policy;
          if (tab == gBrowser.selectedTab)
            this.indicatorSet(policy);
        }
        
        break;
      
      default:
        break;
    }
  },
  
  getImagesFromSelection: function() {
    let selection = window.content.getSelection();
    if (selection.isCollapsed)
      return [];
    
    let images = [],
        imagesHash = {};
    
    let [, doc] = this.getTabAndDoc();
    
    this.forEachXPathResult(doc,
      
      "//*[@ilo-ph-fix]",
      
      function(aNode) {
        let nodeSrc = aNode.getAttribute("ilo-full-src");
        if (nodeSrc && !imagesHash[nodeSrc] && selection.containsNode(aNode, false)) {
          imagesHash[nodeSrc] = true;
          images.push(aNode);
        }
      }
    );
    
    return images;
  },
  
  getImagesFromPoint: function(aTarget, aClientX, aClientY) {
    let ownerDoc = aTarget.ownerDocument;
    
    let images = [],
        imageFromPoint,
        hiddenElements = [],
        elementFromPoint,
        i = 0;
    
    while (i++ < 3 && (elementFromPoint = ownerDoc.elementFromPoint(aClientX, aClientY))) {
      if ((imageFromPoint = this.getImageFromTarget(elementFromPoint)))
        images.push(imageFromPoint);
      
      elementFromPoint.style.visibility = "hidden";
      hiddenElements.push(elementFromPoint);
    }
    
    hiddenElements.forEach(function(aElement) {
      aElement.style.visibility = "visible";
    });
    
    return images;
  },
  
  getImageFromTarget: function(aTarget) {
    if (!aTarget)
      return null;
    
    if (aTarget instanceof Components.interfaces.nsIImageLoadingContent)
      return aTarget.getAttribute("ilo-full-src") ? aTarget : null;
    
    // check AREA/MAP image
    if ("tagName" in aTarget && aTarget.tagName == "AREA") {
      let map = aTarget.parentNode;
      if (map.tagName == "MAP" && map.name)
        return this.getImageFromTarget(this.getXPathResult(aTarget.ownerDocument,
                                   "//img[@usemap='#" + map.name + "']")
                                   .snapshotItem(0));
    }
    
    return null;
  },
  
  //[2do] move to xbl
  setButton: function() {
    let toolbarButton = document.getElementById("ilo-toolbar-button");
    let statusbarButton = document.getElementById("ilo-statusbar-button");

    if (toolbarButton) {
      this.button = toolbarButton;
      statusbarButton.parentNode.style.display = "none";
    } else {
      this.button = statusbarButton;
      statusbarButton.parentNode.style.display = "";
    }
    
    this.indicatorSet(this.browser.selectedBrowser.iloTabPolicy);
  },
  
  log: function(msg) {
    this.nsIImgLikeOpera. log(msg);
  },
  
  dump: function(aObject) {
    this.nsIImgLikeOpera. dump(aObject);
  }
};

window.addEventListener("load",   function(){ILO.onLoad()}, false);
window.addEventListener("unload", function(){ILO.unLoad()}, false);
window.addEventListener("delayLoadRefresher", ILO, false);
