function ILODocData(aTab) {
  this.clearURLStatus();
  
  this._policy = aTab.iloTabPolicy;
  this._delayPolicy = null;
  
  let wnd = aTab.contentDocument.defaultView;
  wnd.document.iloData = this;
  
  let delay = gILO.settings.delayLoad;
  if (delay && this.policy < 3) {
    this.delayPolicy = true;
    
    wnd.addEventListener("load",
      function() {
        this.setTimeout(function() {
          let refreshEvent = this.document.createEvent("UIEvents");
          refreshEvent.initEvent("delayLoadRefresher", true, false);
          this.document.dispatchEvent(refreshEvent);
        }, delay)
      },
    false);
  }
}

ILODocData.prototype = {
  URL_PASS: 1,
  URL_BLOCK: -1,
  
  clearURLStatus: function() {
    this._ulrsData = {
      __proto__: null
    };
  },
  
  get policy() {
    return this._policy;
  },
  
  set policy(aValue) {
    this._policy = aValue;
    return this.policy;
  },
  
  get delayPolicy() {
    return this._delayPolicy;
  },
  
  set delayPolicy(aValue) {
    if (aValue == null) {
      this.policy = this._delayPolicy;
      this._delayPolicy = null;
    } else if (this._delayPolicy == null) {
      this._delayPolicy = this.policy;
      this.policy = 4;
    }
    
    return this._delayPolicy;
  },
  
  getURLStatus: function(aURL) {
    return aURL ? (this._ulrsData[aURL] || null) : null;
  },
  
  passURL: function(aURL) {
    this._ulrsData[aURL] = this.URL_PASS;
  },
  
  blockURL: function(aURL) {
    this._ulrsData[aURL] = this.URL_BLOCK;
  }
}